﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Collections;
using System.Data.Odbc;


namespace AjpdSoftIndexarTextoFicherosPDF
{
    public partial class formIndexarPDF : Form
    {

        Utilidades util = new Utilidades();        
        
        public formIndexarPDF()
        {
            InitializeComponent();
        }

        private void btInsertarDocPDFIndexar_Click(object sender, EventArgs e)
        {
            dlAbrir.CheckFileExists = true;
            dlAbrir.CheckPathExists = true;
            dlAbrir.Multiselect = true;
            dlAbrir.DefaultExt = "pdf";
            dlAbrir.FileName = "";
            dlAbrir.Filter = "Archivos PDF (*.pdf)|*.pdf|Todos los archivos (*.*)|*.*";
            dlAbrir.Title = "Seleccionar fichero PDF a dividir y separar páginas";
            if (dlAbrir.ShowDialog() == DialogResult.OK)
            {
                lsPDFIndexar.Items.AddRange(dlAbrir.FileNames);
                for (int i = 0; i < lsPDFIndexar.Items.Count; ++i)
                    lsPDFIndexar.SetItemChecked(i, true);
            }         
        }

        private void btIndexarPDF_Click(object sender, EventArgs e)
        {
            if (lsPDFIndexar.CheckedItems.Count != 0)
            {
                string textoIndexadoPDFTodos = "";
                string textoIndexadoPDFActual = "";
                string ficheroPDFIndexar = "";
                string mMetadatos = "";
                int numElementos = lsPDFIndexar.CheckedItems.Count;

                this.Cursor = Cursors.WaitCursor;
                bp.Minimum = 0;
                bp.Maximum = numElementos - 1;
                bp.Value = 0;

                for (int i = 0; i <= lsPDFIndexar.CheckedItems.Count - 1; i++)
                {
                    ficheroPDFIndexar = lsPDFIndexar.CheckedItems[i].ToString();
                    bp.Value = i;
                    lInfo.Text = Convert.ToString(i + 1) +
                        "/" + Convert.ToString(numElementos) +
                        " [" + Path.GetFileName(ficheroPDFIndexar) + "]";
                    Application.DoEvents();
                    //obtener metadatos del fichero PDF
                    mMetadatos = util.obtenerMetaDatosFicheroPDF(ficheroPDFIndexar);
                    //obtener el texto del PDF
                    textoIndexadoPDFActual = util.obtenerTextoFicheroPDF(ficheroPDFIndexar);

                    if (textoIndexadoPDFTodos != "")
                    {
                        textoIndexadoPDFTodos = textoIndexadoPDFTodos +
                            Environment.NewLine + Environment.NewLine +
                            "==================================" +
                            Environment.NewLine + Environment.NewLine +
                            "Fichero: " + ficheroPDFIndexar + Environment.NewLine +
                            mMetadatos + Environment.NewLine + textoIndexadoPDFActual;
                    }
                    else
                    {
                        textoIndexadoPDFTodos =
                            "Fichero: " + ficheroPDFIndexar + Environment.NewLine +
                            mMetadatos + Environment.NewLine + textoIndexadoPDFActual;
                    }
                }
                txtResultadoIndexacionPDF.Text = textoIndexadoPDFTodos;
                this.Cursor = Cursors.Default;
                lInfo.Text = "Proceso de indexación de PDF finalizado";
                bp.Value = 0;
                MessageBox.Show("Proceso de indexación de PDF finalizado correctamente.",
                    "Fin proceso", MessageBoxButtons.OK, MessageBoxIcon.Information); 
            }
            else
            {
                btInsertarDocPDFIndexar.Focus();
                MessageBox.Show("Debe chequear los ficheros PDF a indexar a pantalla.", 
                    "Seleccionar PDF", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void btSelTodos_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < lsPDFIndexar.Items.Count; i++)
            {
                lsPDFIndexar.SetItemChecked(i, true);
            }
        }

        private void btNinguno_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < lsPDFIndexar.Items.Count; i++)
            {
                lsPDFIndexar.SetItemChecked(i, false);
            }
        }

        private void btInvertir_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < lsPDFIndexar.Items.Count; i++)
            {
                lsPDFIndexar.SetItemChecked(i, ! lsPDFIndexar.GetItemChecked(i));
            }
        }

        private void bConectar_Click(object sender, EventArgs e)
        {
            if (txtTabla.Text != "")  
            {
                try
                {
                    if (lsODBC.Text != "")
                    {
                        util.conexionBDODBC = new OdbcConnection("dsn=" + lsODBC.Text +
                            ";UID=" + txtUsuario.Text + ";PWD=" + txtContrasena.Text + ";");
                    }
                    else
                    {
                        if (txtPuerto.Text != "")
                        {
                            util.conexionBDODBC = new OdbcConnection("DRIVER={" + lsMotor.Text +
                                "};SERVER=" + txtServidor.Text + "; PORT=" + txtPuerto.Text +
                                ";UID=" + txtUsuario.Text +
                                ";PWD=" + txtContrasena.Text + ";" +
                                ";DATABASE=" + txtBD.Text + ";");
                        }
                        else
                        {
                            util.conexionBDODBC = new OdbcConnection("DRIVER={" + lsMotor.Text +
                                "};SERVER=" + txtServidor.Text + ";UID=" + txtUsuario.Text +
                                ";PWD=" + txtContrasena.Text + ";" +
                                ";DATABASE=" + txtBD.Text + ";");
                        }
                    }

                    util.conexionBDODBC.Open();

                    if (util.conexionBDODBC.State == ConnectionState.Open)
                    {
                        bDesconectar.Enabled = true;
                        bConectar.Enabled = false;

                        OdbcCommand comandoSQL;
                        string consultaSQL;

                        consultaSQL = "Select count(*) from " + txtTabla.Text;
                        try
                        {
                            comandoSQL = new OdbcCommand(consultaSQL, util.conexionBDODBC);
                            int numeroRegistros = Convert.ToInt32(comandoSQL.ExecuteScalar());
                            MessageBox.Show("La tabla " + txtTabla.Text + " existe con " +
                                Convert.ToString(numeroRegistros) + " registros.", "Conexión BD",
                            MessageBoxButtons.OK, MessageBoxIcon.Information);
                            beConectadoBD.Text = "Conectado a BD";
                            bDesconectar.Enabled = true;
                            bConectar.Enabled = false;
                        }
                        catch (Exception ex)
                        {
                            util.conexionBDODBC.Close();
                            bDesconectar.Enabled = false;
                            bConectar.Enabled = true;
                            MessageBox.Show("Error al ejecutar SQL: " +
                                System.Environment.NewLine + System.Environment.NewLine +
                                ex.GetType().ToString() + System.Environment.NewLine +
                                ex.Message, "Error",
                                MessageBoxButtons.OK, MessageBoxIcon.Error);
                        }
                    }
                    else
                    {
                        beConectadoBD.Text = "No conectado a BD";
                        bDesconectar.Enabled = false;
                        bConectar.Enabled = true;
                        MessageBox.Show("No conectado a la base de datos.", "Conexión BD",
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
                catch (Exception error)
                {
                    bDesconectar.Enabled = false;
                    bConectar.Enabled = true;
                    beConectadoBD.Text = "No conectado a BD";
                    util.conexionBDODBC.Close();
                    MessageBox.Show("Error de base de datos: " +
                        System.Environment.NewLine + System.Environment.NewLine +
                        error.GetType().ToString() + System.Environment.NewLine +
                        error.Message, "Error al crear PDF",
                        MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                
            }            
            else
            {
                MessageBox.Show("Debe indicar el nombre de la tabla de " +
                    "la BD donde se crearán los registros " +
                    "con el indexado del los PDF.", "Tabla",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtTabla.Focus();
            }            
        }

        private void btListaODBC_Click(object sender, EventArgs e)
        {
            SortedList listaODBC = new System.Collections.SortedList();
            lsODBC.Items.Clear();
            listaODBC = util.obtenerDataSourcesSistema();
            foreach (DictionaryEntry key in listaODBC)
            {
                lsODBC.Items.Add(key.Key.ToString());
            }
            listaODBC = util.obtenerDataSourcesUsuario();
            foreach (DictionaryEntry key in listaODBC)
            {
                lsODBC.Items.Add(key.Key.ToString());
            }
        }

        private void btGuardarTextoFichero_Click(object sender, EventArgs e)
        {
            dlGuardar.Title = "Selección de carpeta y fichero de " +
                "texto donde se guardará la indexación";
            dlGuardar.Filter = "Texto (*.txt)|*.txt|Todos los ficheros (*.*)|*.*";
            dlGuardar.DefaultExt = "txt";
            dlGuardar.FilterIndex = 1;
            dlGuardar.CheckFileExists = false;
            dlGuardar.OverwritePrompt = true;
            if (dlGuardar.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    StreamWriter ficheroTexto = new StreamWriter(dlGuardar.FileName,
                        false, System.Text.Encoding.Default);
                    ficheroTexto.Write(txtResultadoIndexacionPDF.Text);
                    ficheroTexto.Flush();
                    ficheroTexto.Close();
                    MessageBox.Show("Fichero de texto guardado correctamente.", 
                        "Fichero guardado",
                        MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Error al guardar fichero de texto: " +
                        System.Environment.NewLine + System.Environment.NewLine +
                        ex.GetType().ToString() + System.Environment.NewLine +
                        ex.Message, "Error",
                        MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void bDesconectar_Click(object sender, EventArgs e)
        {
            try
            {
                util.conexionBDODBC.Close();
                bDesconectar.Enabled = false;                
                bConectar.Enabled = true;
                beConectadoBD.Text = "No conectado a BD";
                bConectar.Focus();
            }
            catch (Exception error)
            {
                bDesconectar.Enabled = false;
                bConectar.Enabled = true;
                MessageBox.Show("Error de base de datos: " +
                    System.Environment.NewLine + System.Environment.NewLine +
                    error.GetType().ToString() + System.Environment.NewLine +
                    error.Message, "Error al crear PDF",
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void btIndexarPDFBD_Click(object sender, EventArgs e)
        {
            if (util.conexionBDODBC.State == ConnectionState.Open)
            {
                if (lsPDFIndexar.CheckedItems.Count != 0)
                {
                    string textoIndexadoPDF = "";
                    string ficheroPDFIndexar = "";
                    string mMetadatos = "";
                    int numElementos = lsPDFIndexar.CheckedItems.Count;

                    this.Cursor = Cursors.WaitCursor;
                    bp.Minimum = 0;
                    bp.Maximum = numElementos - 1;
                    bp.Value = 0;

                    for (int i = 0; i <= numElementos - 1; i++)
                    {
                        bp.Value = i;
                        ficheroPDFIndexar = lsPDFIndexar.CheckedItems[i].ToString();
                        lInfo.Text = Convert.ToString(i + 1) +
                            "/" + Convert.ToString(numElementos) + 
                            " [" + Path.GetFileName (ficheroPDFIndexar) + "]";
                        Application.DoEvents();
                        //Obtener metadatos del fichero PDF
                        mMetadatos = util.obtenerMetaDatosFicheroPDF(ficheroPDFIndexar);
                        //obtener texto indexado del PDF
                        textoIndexadoPDF = util.obtenerTextoFicheroPDF(ficheroPDFIndexar);
                        util.insertarRegistroBD(ficheroPDFIndexar, textoIndexadoPDF,
                              mMetadatos, txtCampoFicheroPDF.Text, 
                              txtCampoTextoPDF.Text, txtCampoMetadatosPDF.Text,
                              txtTabla.Text, txtCampoFecha.Text, opBDIndexarReemplazar.Checked);                            
                    }
                    this.Cursor = Cursors.Default;
                    lInfo.Text = "Proceso de indexación de PDF finalizado";
                    bp.Value = 0;
                    util.conexionBDODBC.Close();
                    bConectar.Enabled = true;
                    bDesconectar.Enabled = false;
                    beConectadoBD.Text = "No conectado a BD";
                    MessageBox.Show("Proceso de indexación de PDF finalizado correctamente.",
                        "Fin proceso", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    btInsertarDocPDFIndexar.Focus();
                    MessageBox.Show("Debe chequear los ficheros PDF a indexar a base de datos.",
                        "Seleccionar PDF", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }
            else
            {
                MessageBox.Show("Debe estar conectado a la base de datos para " +
                    "realizar la indexación de los ficheros PDF seleccionados.", 
                    "Error al crear PDF", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }


        private void formIndexarPDF_FormClosed(object sender, FormClosedEventArgs e)
        {
            Utilidades proUtilidades = new Utilidades();
            cifrarAES cifradoAES = new cifrarAES();
 
            proUtilidades.guardarValorConfiguracion("BD.ODBC", lsODBC.Text);    
            proUtilidades.guardarValorConfiguracion("BD.Motor", lsMotor.Text);
            proUtilidades.guardarValorConfiguracion("BD.Servidor", txtServidor.Text);
            proUtilidades.guardarValorConfiguracion("BD.Usuario", txtUsuario.Text);
            proUtilidades.guardarValorConfiguracion("BD.Contraseña", 
                cifradoAES.cifrarTextoAES (txtContrasena.Text,
                "AjpdSoft_Frase_Encriptado", "AjpdSoft_Frase_Encriptado", 
                "MD5", 22, "1234567891234567", 128));
            proUtilidades.guardarValorConfiguracion("BD.Base_Datos", txtBD.Text);
            proUtilidades.guardarValorConfiguracion("BD.Puerto", txtPuerto.Text);
            proUtilidades.guardarValorConfiguracion("BD.Tabla", txtTabla.Text);
            proUtilidades.guardarValorConfiguracion("BD.Campo_Texto_Indexado", 
                txtCampoTextoPDF.Text);
            proUtilidades.guardarValorConfiguracion("BD.Campo_Fecha", 
                txtCampoFecha.Text);    
            proUtilidades.guardarValorConfiguracion("BD.Campo_Metadatos", 
                txtCampoMetadatosPDF.Text);
            proUtilidades.guardarValorConfiguracion("BD.Campo_Fichero_PDF", 
                txtCampoFicheroPDF.Text);
        }

        private void btSQL_Click(object sender, EventArgs e)
        {
            formSQL frmSQL = new formSQL();
            frmSQL.ShowDialog();
        }

        private void formIndexarPDF_Load(object sender, EventArgs e)
        {                    
            Utilidades proUtilidades = new Utilidades();
            cifrarAES cifradoAES = new cifrarAES();

            lsODBC.Text = 
                proUtilidades.leerValorConfiguracion("BD.ODBC");
            lsMotor.Text = 
                proUtilidades.leerValorConfiguracion("BD.Motor");
            txtServidor.Text = 
                proUtilidades.leerValorConfiguracion("BD.Servidor");
            txtUsuario.Text = 
                proUtilidades.leerValorConfiguracion("BD.Usuario");
            txtContrasena.Text =
                cifradoAES.descifrarTextoAES(
                  proUtilidades.leerValorConfiguracion("BD.Contraseña"),
                  "AjpdSoft_Frase_Encriptado", "AjpdSoft_Frase_Encriptado", 
                  "MD5", 22, "1234567891234567", 128);
            txtBD.Text = 
                proUtilidades.leerValorConfiguracion("BD.Base_Datos");
            txtPuerto.Text = 
                proUtilidades.leerValorConfiguracion("BD.Puerto");
            txtTabla.Text= 
                proUtilidades.leerValorConfiguracion("BD.Tabla");
            txtCampoTextoPDF.Text = 
                proUtilidades.leerValorConfiguracion("BD.Campo_Texto_Indexado");            
            txtCampoFecha.Text = 
                proUtilidades.leerValorConfiguracion("BD.Campo_Fecha");
            txtCampoMetadatosPDF.Text = 
                proUtilidades.leerValorConfiguracion("BD.Campo_Metadatos");
            txtCampoFicheroPDF.Text = 
                proUtilidades.leerValorConfiguracion("BD.Campo_Fichero_PDF");
        }

        private void toolStripStatusLabel1_Click_1(object sender, EventArgs e)
        {
            //abrir navegador por defecto y acceder a la URL www.ajpdsoft.com
            System.Diagnostics.Process.Start("http://www.ajpdsoft.com");
        }
    }
}
